clear all
set more off
cap log close
*cd "X:\Dga_EI\AMicro\TRABAJO\FLIT_evaluacion_2014-2015\2020_version\"
*cd "F:\BdE_11032020\FLIT_evaluacion_2014-2015\2020_version\"
*cd "D:\Dropbox\BdE\EducacionFinanciera\Programa Escolar\2015\Evaluation\2020_version\"
cd "C:\Trabajo\new_projects\FInancial-literacy-eval 2014-2015\FpT corto\evaluation2015_ana"

log using "Logfiles\Generating inputs at strata level.log", replace

******************************
**** Table 2: Titularidad ****
******************************

use "Datafiles\Students", clear
keep if curso==3
drop curso december_observaciones march_observaciones june_observaciones  june_curso december_CA* family_* march_CA* march_PP* fecha_nacimiento año_nacimiento mes_nacimiento dia_nacimiento sexo female female_mis native foreign foreign_mis stratum stratum_c ccaa ccomu provincia cprov nom_muni cmuni tam /*
*/ pobl school_* madrid madrid2 publico2 concpri2 dec100* mar100* E_drop* daily0 onceweek0 bonceweek0 nevertalk0 talk0_mis freq_cont0 daily1 onceweek1 bonceweek1 nevertalk1 talk1_mis freq_cont1 paga_* /*
*/ repetidores repetidores_mis trab_* labor_* venta_* labor_outside_* labor_income_* autonomop trabajaempp paradop other_labp autonomop_mis autonomom trabajaempm paradom other_labm autonomom_mis J1 J2 J3 J4 J5 J6 J7 J8 J9 /*
*/ sum_correct juego* _merge stra* stratum_c*
qui compress
gen CL_PROF1=march_CL_PROF1 if march_CL_PROF1!=""
replace CL_PROF1=june_CL_PROF1 if june_CL_PROF1!=""&CL_PROF1==""
gen CL_PROF2=march_CL_PROF2 if march_CL_PROF2!=""
replace CL_PROF2=june_CL_PROF2 if june_CL_PROF2!=""&CL_PROF2==""
gen CL_PROF3=march_CL_PROF3 if march_CL_PROF3!=""
replace CL_PROF3=june_CL_PROF3 if june_CL_PROF3!=""&CL_PROF3==""
drop march_CL_PROF* june_CL_PROF*

egen t = group(COD_CENTRO GRUPO_NATURAL)
replace t=90 if  t==.&COD_CENTRO ==XXX
replace t=93 if  t==.&COD_CENTRO ==XXX
replace t=84 if  t==.&COD_CENTRO ==XXX
replace t=162 if  t==.&COD_CENTRO ==XXX
replace t=171 if  t==.&COD_CENTRO ==XXX
replace t=172 if  t==.&COD_CENTRO ==XXX
replace t=173 if  t==.&COD_CENTRO ==XXX
replace t=174 if  t==.&COD_CENTRO ==XXX
replace t=175 if  t==.&COD_CENTRO ==XXX
replace t=176 if  t==.&COD_CENTRO ==XXX
replace t=177 if  t==.&COD_CENTRO ==XXX
replace t=178 if  t==.&COD_CENTRO ==XXX
replace t=179 if  t==.&COD_CENTRO ==XXX
replace t=180 if  t==.&COD_CENTRO ==XXX
replace t=181 if  t==.&COD_CENTRO ==XXX

replace t=137 if t==138|t==139|t==140|t==141|t==142
sort t idestu
gen maxCL_PROF1=CL_PROF1
replace maxCL_PROF1=maxCL_PROF1[_n-1] if maxCL_PROF1==""&maxCL_PROF1[_n-1]!=""&t==t[_n-1]
gen maxCL_PROF2=CL_PROF2
replace maxCL_PROF2=maxCL_PROF2[_n-1] if maxCL_PROF2==""&maxCL_PROF2[_n-1]!=""&t==t[_n-1]
gen maxCL_PROF3=CL_PROF3
replace maxCL_PROF3=maxCL_PROF3[_n-1] if maxCL_PROF3==""&maxCL_PROF3[_n-1]!=""&t==t[_n-1]
forvalues i=1(1)20{
	qui replace maxCL_PROF1=maxCL_PROF1[_n+1] if maxCL_PROF1==""&maxCL_PROF1[_n+1]!=""&t==t[_n+1]
	qui replace maxCL_PROF2=maxCL_PROF2[_n+1] if maxCL_PROF2==""&maxCL_PROF2[_n+1]!=""&t==t[_n+1]
	qui replace maxCL_PROF3=maxCL_PROF3[_n+1] if maxCL_PROF3==""&maxCL_PROF3[_n+1]!=""&t==t[_n+1]      
}
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="PF" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="-" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="-" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="-" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX
replace GRUPO_DEL_CURSO="A" if idestu==2198
replace GRUPO_DEL_CURSO="B" if idestu==1171
replace GRUPO_DEL_CURSO="B" if COD_CENTRO==XXX&GRUPO_DEL_CURSO==""
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX&GRUPO_DEL_CURSO==""
replace GRUPO_DEL_CURSO="A" if COD_CENTRO==XXX&GRUPO_DEL_CURSO=="B"&maxCL_PROF1=="XXXX"
drop clav t sum_teachers CL_PROF1 CL_PROF2 CL_PROF3 december_Asistencia pretest altasybajas participacion compliance march_Asistencia postest merge_students balancing_test balanced_sample june_ESTADO1 june_ESTADO2 june_ESTADO3 june_Asistencia june_postest june_balanced_sample
drop if maxCL_PROF1==""
qui compress
save temp_prof, replace

use temp_prof, clear
drop maxCL_PROF2 maxCL_PROF3
rename maxCL_PROF1 cl_prof
sort idestu cl_prof 
save temp1, replace

use temp_prof, clear
drop maxCL_PROF1 maxCL_PROF3
rename maxCL_PROF2 cl_prof
drop if cl_prof==""
qui compress
sort idestu cl_prof 
save temp2, replace

use temp_prof, clear
drop maxCL_PROF1 maxCL_PROF2
rename maxCL_PROF3 cl_prof
drop if cl_prof==""
qui compress
sort idestu cl_prof 
save temp3, replace

use "Datafiles\Teachers.dta", clear
keep cl_prof teacher*
qui compress
sort cl_prof
save "Datafiles\Teachers_temp.dta", replace

use temp1, clear
append using temp2
append using temp3
order  cl_prof idestu
sort cl_prof idestu 
merge cl_prof using "Datafiles\Teachers_temp.dta"
drop _merge
qui compress
save "Datafiles\Students3Teachers", replace

erase temp1.dta
erase temp2.dta
erase temp3.dta
erase "Datafiles\Teachers_temp.dta"


**** Table 2 ****
use "Datafiles\Students3Teachers", clear
keep if treated==1
bys COD_CENTRO: egen maxpublico=max(publico)
drop publico 
rename maxpublico publico
bys COD_CENTRO: egen maxconcertado=max(concertado)
drop concertado 
rename maxconcertado concertado
bys COD_CENTRO: egen maxprivado=max(privado)
drop privado
rename maxprivado privado
bys COD_CENTRO: egen maxconcpri=max(concpri)
drop concpri
rename maxconcpri concpri

bys COD_CENTRO: gen ncentro=_n
tab nom* if ncentro==1
bys cl_prof: gen nprof=_n
*** Teacher's specialization ***
tab teacher_social_science if nprof==1
tab teacher_economics if nprof==1
tab teacher_math if nprof==1
tab teacher_computing_science if nprof==1
tab teacher_other if nprof==1

replace GRUPO_DEL_CURSO="C-E" if COD_CENTRO==ZZZZ& cl_prof=="ZZZZ"&GRUPO_DEL_CURSO=="1"
replace GRUPO_DEL_CURSO="DIV" if COD_CENTRO==ZZZZ& cl_prof=="ZZZZ"&GRUPO_DEL_CURSO=="3"
replace GRUPO_DEL_CURSO="a-d-f" if COD_CENTRO==ZZZZ& cl_prof=="ZZZ"

gen horas=teacher_p11a1d if GRUPO_DEL_CURSO==teacher_p11a1b
replace horas=teacher_p11a2d if horas==.&teacher_p11a2d!=0&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace horas=teacher_p11a3d if horas==.&teacher_p11a3d!=0&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace horas=teacher_p11a4d if horas==.&teacher_p11a4d!=0&(GRUPO_DEL_CURSO==teacher_p11a4b)
drop if horas==.
drop teacher_p11a1d teacher_p11a2d teacher_p11a3d teacher_p11a4d
bys idestu: egen sumhoras=sum(horas)
gen fraction_horas=horas/sumhoras 

gen lessons_1=(teacher_p14a1_1!=0)
gen lessons_2=(teacher_p14a2_1!=0)
gen lessons_3=(teacher_p14a3_1!=0)
gen lessons_4=(teacher_p14a4_1!=0)
local i=2
while	`i'<=10 {
	replace lessons_1=lessons_1+1 if teacher_p14a1_`i'!=0
	replace lessons_2=lessons_2+1 if teacher_p14a2_`i'!=0
	replace lessons_3=lessons_3+1 if teacher_p14a3_`i'!=0
	replace lessons_4=lessons_4+1 if teacher_p14a4_`i'!=0
local i = `i' + 1
}
drop teacher_p14a1* teacher_p14a2* teacher_p14a3* teacher_p14a4*
gen lessons=lessons_1 if GRUPO_DEL_CURSO==teacher_p11a1b
replace lessons=lessons_2 if lessons==.&lessons_2!=0&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace lessons=lessons_3 if lessons==.&lessons_3!=0&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace lessons=lessons_4 if lessons==.&lessons_4!=0&(GRUPO_DEL_CURSO==teacher_p11a4b)
bys idestu: egen maxlessons=max(lessons)
drop lessons_*

gen homework=1 if teacher_p20a1==1&GRUPO_DEL_CURSO==teacher_p11a1b
replace homework=0 if homework==.&teacher_p20a1==2&GRUPO_DEL_CURSO==teacher_p11a1b
replace homework=1 if homework==.&teacher_p20a2==1&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace homework=0 if homework==.&teacher_p20a2==2&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace homework=1 if homework==.&teacher_p20a3==1&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace homework=0 if homework==.&teacher_p20a3==2&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace homework=1 if homework==.&teacher_p20a4==1&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace homework=0 if homework==.&teacher_p20a4==2&(GRUPO_DEL_CURSO==teacher_p11a4b)
bys idestu: egen maxhomework=max(homework)
drop teacher_p20a*

gen evaluation=1 if teacher_p21a1==1&GRUPO_DEL_CURSO==teacher_p11a1b
replace evaluation=0 if evaluation==.&teacher_p21a1==2&GRUPO_DEL_CURSO==teacher_p11a1b
replace evaluation=1 if evaluation==.&teacher_p21a2==1&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace evaluation=0 if evaluation==.&teacher_p21a2==2&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace evaluation=1 if evaluation==.&teacher_p21a3==1&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace evaluation=0 if evaluation==.&teacher_p21a3==2&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace evaluation=1 if evaluation==.&teacher_p21a4==1&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace evaluation=0 if evaluation==.&teacher_p21a4==2&(GRUPO_DEL_CURSO==teacher_p11a4b)
bys idestu: egen maxevaluation=max(evaluation)
drop teacher_p21a*

gen teacher_id=1 if GRUPO_DEL_CURSO==teacher_p11a1b
replace teacher_id=2 if GRUPO_DEL_CURSO==teacher_p11a2b
replace teacher_id=3 if GRUPO_DEL_CURSO==teacher_p11a3b
replace teacher_id=4 if GRUPO_DEL_CURSO==teacher_p11a4b

gen math=1 if teacher_p13a1_1==17&(GRUPO_DEL_CURSO==teacher_p11a1b)
replace math=1 if math==.&teacher_p13a2_1==17&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace math=1 if math==.&teacher_p13a3_1==17&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace math=1 if math==.&teacher_p13a4_1==17&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace math=0 if math==.
bys idestu: egen maxmath=max(math)

gen subject=1 if math==1

gen social_sciences=1 if (teacher_p13a1_1==3|teacher_p13a1_1==9|teacher_p13a1_1==10|teacher_p13a1_1==15)&(GRUPO_DEL_CURSO==teacher_p11a1b)
replace social_sciences=1 if social_sciences==.&(teacher_p13a2_1==3|teacher_p13a2_1==9|teacher_p13a2_1==10|teacher_p13a2_1==15)&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace social_sciences=1 if social_sciences==.&(teacher_p13a3_1==3|teacher_p13a3_1==9|teacher_p13a3_1==10|teacher_p13a3_1==15)&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace social_sciences=1 if social_sciences==.&(teacher_p13a4_1==3|teacher_p13a4_1==9|teacher_p13a4_1==10|teacher_p13a4_1==15)&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace social_sciences=0 if social_sciences==.
bys idestu: egen maxsocial_sciences=max(social_sciences)

replace subject=2 if social_sciences==1

gen tutor=1 if (teacher_p13a1_1==20)&(GRUPO_DEL_CURSO==teacher_p11a1b)
replace tutor=1 if tutor==.&(teacher_p13a2_1==20)&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace tutor=1 if tutor==.&(teacher_p13a3_1==20)&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace tutor=1 if tutor==.&(teacher_p13a4_1==20)&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace tutor=0 if tutor==.
bys idestu: egen maxtutor=max(tutor)

replace subject=3 if tutor==1

gen citizenship=1 if (teacher_p13a1_1==7|teacher_p13a1_1==5)&(GRUPO_DEL_CURSO==teacher_p11a1b)
replace citizenship=1 if citizenship==.&(teacher_p13a2_1==7|teacher_p13a2_1==5)&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace citizenship=1 if citizenship==.&(teacher_p13a3_1==7|teacher_p13a3_1==5)&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace citizenship=1 if citizenship==.&(teacher_p13a4_1==7|teacher_p13a4_1==5)&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace citizenship=0 if citizenship==.
bys idestu: egen maxcitizenship=max(citizenship)

replace subject=4 if citizenship==1

gen alternative=1 if (teacher_p13a1_1==1)&(GRUPO_DEL_CURSO==teacher_p11a1b)
replace alternative=1 if alternative==.&(teacher_p13a2_1==1)&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace alternative=1 if alternative==.&(teacher_p13a3_1==1)&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace alternative=1 if alternative==.&(teacher_p13a4_1==1)&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace alternative=0 if alternative==.
bys idestu: egen maxalternative=max(alternative)

replace subject=5 if alternative==1

gen other=1 if (teacher_p13a1_1==4|teacher_p13a1_1==6|teacher_p13a1_1==11|teacher_p13a1_1==12|teacher_p13a1_1==13|teacher_p13a1_1==16|teacher_p13a1_1==19|teacher_p13a1_1==21|teacher_p13a1_1==22)&(GRUPO_DEL_CURSO==teacher_p11a1b)
replace other=1 if other==.&(teacher_p13a2_1==4|teacher_p13a2_1==6|teacher_p13a2_1==11|teacher_p13a2_1==12|teacher_p13a2_1==13|teacher_p13a2_1==16|teacher_p13a2_1==19|teacher_p13a2_1==21|teacher_p13a2_1==22)&(GRUPO_DEL_CURSO==teacher_p11a2b)
replace other=1 if other==.&(teacher_p13a3_1==4|teacher_p13a3_2==6|teacher_p13a3_1==11|teacher_p13a3_1==12|teacher_p13a3_1==13|teacher_p13a3_1==16|teacher_p13a3_1==19|teacher_p13a3_1==21|teacher_p13a3_1==22)&(GRUPO_DEL_CURSO==teacher_p11a3b)
replace other=1 if other==.&(teacher_p13a4_1==4|teacher_p13a4_3==6|teacher_p13a4_1==11|teacher_p13a4_1==12|teacher_p13a4_1==13|teacher_p13a4_1==16|teacher_p13a4_1==19|teacher_p13a4_1==21|teacher_p13a4_1==22)&(GRUPO_DEL_CURSO==teacher_p11a4b)
replace other=0 if other==.
bys idestu: egen maxother=max(other)

replace subject=6 if other==1

label define subjectlab 1 "math" 2 "social sciences" 3 "tutor" 4 "citizenship" 5 "alternative" 6 "other"
label values subject subjectlab

bys idestu (fraction_horas): gen n=_n
bys idestu (fraction_horas): gen N=_N
keep if n==N
*** Total number of hours per student ***
sum sumhoras,det
foreach x in publico concertado privado concpri {
di "Total number of hours per student: `x'==1"
sum sumhoras if `x'==1,det
}
*** Maximun number of lessons per student ***
sum maxlessons,det
foreach x in publico concertado privado concpri {
di "Maximun number of lessons per student: `x'==1"
sum maxlessons if `x'==1,det
}
*** Students with at least one teacher that made independent evaluation & homework ***
sum maxevaluation maxhomework 
foreach x in publico concertado privado concpri {
di "Students with at least one teacher that made independent evaluation & homework: `x'==1"
sum maxevaluation maxhomework if `x'==1
}
*** Subject with the teacher that devote more time ***
tab subject,m
foreach x in publico concertado privado concpri {
di "Subject with the teacher that devote more time: `x'==1"
tab subject if `x'==1,m
}
*** Teacher's specialization ***
global teacher_specialization teacher_social_science teacher_economics teacher_math teacher_computing_science teacher_other
sum $teacher_specialization
foreach x in publico concertado privado concpri {
di "Teacher's specialization: `x'==1"
sum $teacher_specialization if `x'==1
}
/* STEPS ERASED FIE TO ANONYMIZATION*/

label define stratuml 1 "Madrid públicos 1st"
label define stratuml 2 "Madrid concertados 1st", add
label define stratuml 3 "Madrid privados 1st", add
label define stratuml 4 "Resto CCAA públicos 1st", add
label define stratuml 5 "Resto CCAA concertados 1st", add
label define stratuml 6 "Resto CCAA privados 1st", add
label define stratuml 7 "Madrid públicos 2nd", add
label define stratuml 8 "Madrid privados 2nd", add
label define stratuml 9 "Resto CCAA públicos 2nd", add
label define stratuml 10 "Resto CCAA concertados 2nd", add
label define stratuml 11 "Públicos 3rd", add
label define stratuml 12 "Concertados 3rd", add
label define stratuml 13 "Concertados 4th", add
label define stratuml 14 "Intended to give the material in 7th", add
label define stratuml 15 "Intended to give the material in 8th", add
label define stratuml 16 "Intended to give the material in 1st of upper secondary", add
label values stratum stratuml

** New strata **

gen stratum_c = stratum if (stratum==1|stratum==2|stratum==3|stratum==4|stratum==5|stratum==6|stratum==7|stratum==9|stratum==10|stratum==11|stratum==12|stratum==13|stratum==14|stratum==16)
replace stratum_c = 3 if stratum==8
replace stratum_c = 14 if stratum==15

summ sumhoras maxlessons maxevaluation maxhomework teacher_social_science teacher_economics teacher_math teacher_computing_science teacher_other /*
*/ math social_science tutor citizenship alternative

collapse (mean) sumhoras maxlessons maxevaluation maxhomework teacher_social_science teacher_economics teacher_math teacher_computing_science teacher_other /*
*/ math social_science tutor citizenship alternative, by(stratum_c)

save "Datafiles\Inputs_strata",replace
