clear all
cap log close
set more off
*cd "X:\Dga_EI\AMicro\TRABAJO\FLIT_evaluacion_2014-2015\2020_version\"
*cd "F:\BdE_11032020\FLIT_evaluacion_2014-2015\2020_version\"

cd "C:\Trabajo\new_projects\FInancial-literacy-eval 2014-2015\FpT corto\evaluation2015_ana"

log using "Logfiles\comment3_implementation\4. inputs_by_strata_lag_60pp.log", replace


*****************
**** Table 6 ****
*****************

use "Datafiles\Inputs_strata"

sort stratum_c

merge stratum_c using "C:\Trabajo\new_projects\FInancial-literacy-eval 2014-2015\FpT corto\evaluation2015_ana\Logfiles\comment3_implementation\tests_results_60pp_lag.dta"

/* ************************ PUBLIC VS RIVATE **************************** */
gen publico=(stratum_c==1|stratum_c==4|stratum_c==7|stratum_c==9|stratum_c==11)


** Basics (not shown in the paper)

summ  sumhoras maxlessons maxevaluation maxhomework [aw=Ntest] 


reg Ttest sumhoras  maxevaluation maxlessons [aw=Ntest]

** Teacher characteristics (not shown in the paper)

reg Ttest teacher_social_science teacher_math teacher_computing_science teacher_other  [aw=Ntest]


** BY subject (TABLE 6, PANEL B, COLUMN 2)

summ social_sciences  math citizenship tutor alternative

reg Ttest publico sumhoras math social_sciences [aw=Ntest],r
