set more off
clear all
cap log close

clear all
cap log close
set more off
cd "C:\Users\Usuario\Dropbox\JHR\replication file november\Tables\TableW5"

log using "TableW5_1.log", replace


use "C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\Students", clear


**************************************************************************

keep if curso==3
/** Normalizar notas pretest y postest
gen pretest=sum_correct/30

gen postest=sum_correct2/29 if TIPOCUES2=="A"
replace postest=sum_correct2/30 if TIPOCUES2=="B"
*/
** Cambio en la nota normalizada
sum pretest
gen a=r(mean)
gen b=r(sd)
*gen a=0
*gen b=1
gen norm_pretest=(pretest-a)/b if pretest!=.
replace norm_pretest=0 if pretest==.

drop a b

sum postest
gen a=r(mean)
gen b=r(sd)
gen norm_postest=(postest-a)/b
*drop a b

summ postest norm_postest pretest norm_pretest if treated==1
summ postest norm_postest pretest norm_pretest if treated==0

gen norm_pretestmis=(pretest==.)
replace pretest=0 if norm_pretestmis==1
replace norm_pretest=0 if norm_pretestmis==1



save "C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\temp1",replace

 

************************************************** D-in-D ***************************************

use				"C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\temp1"
gen AFTER=1
append using 	"C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\temp1"


keep norm_postest AFTER norm_pretest norm_pretestmis treated stratum_c2-stratum_c16 COD_CENTRO publico balanced_sample

gen		TEST	=norm_postest 	if AFTER==1
replace TEST	=norm_pretest 	if AFTER==.
replace TEST	=.			 	if AFTER==. & norm_pretestmis==1

gen 	TREAT= treated 
replace TREAT= treated

replace AFTER=0 if AFTER==.

gen TREAT_AFTER=TREAT*AFTER

** Not balanced panel
regress TEST TREAT_AFTER TREAT AFTER, robust cluster(COD_CENTRO)

regress TEST TREAT_AFTER TREAT AFTER stratum_c2-stratum_c16, robust cluster(COD_CENTRO)


**  Balanced panel

regress TEST TREAT_AFTER TREAT AFTER if balanced_sample==1, robust cluster(COD_CENTRO)

** Balanced panel Including strata, with and without individual fixed effects

regress TEST TREAT_AFTER TREAT AFTER stratum_c2-stratum_c16 if balanced_sample==1, robust cluster(COD_CENTRO)



/* *********************************************** TABLE W5 PANEL B: CONTROLS *************************************/


use "C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\Students", clear


**************************************************************************

keep if curso==4

** Cambio en la nota normalizada
sum pretest
gen a=r(mean)
gen b=r(sd)
*gen a=0
*gen b=1
gen norm_pretest=(pretest-a)/b if pretest!=.
replace norm_pretest=0 if pretest==.

drop a b

sum postest
gen a=r(mean)
gen b=r(sd)
gen norm_postest=(postest-a)/b
*drop a b

summ postest norm_postest pretest norm_pretest if treated==1
summ postest norm_postest pretest norm_pretest if treated==0


gen norm_pretestmis=(pretest==.)
replace pretest=0 if norm_pretestmis==1
replace norm_pretest=0 if norm_pretestmis==1


save "C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\temp1",replace

 

************************************************** D-in-D ***************************************

use				"C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\temp1",clear
gen AFTER=1
append using 	"C:\Users\Usuario\Dropbox\JHR\replication file\datafiles\temp1"


*keep norm_postest AFTER norm_pretest norm_pretestmis treated stratum_c2-stratum_c16 COD_CENTRO publico balanced_sample

gen		TEST	=norm_postest 	if AFTER==1
replace TEST	=norm_pretest 	if AFTER==.
replace TEST	=.			 	if AFTER==. & norm_pretestmis==1

gen 	TREAT= treated 
replace TREAT= treated

replace AFTER=0 if AFTER==.

gen TREAT_AFTER=TREAT*AFTER

** Unbalanced panel with and without strata
regress TEST TREAT_AFTER TREAT AFTER, robust cluster(COD_CENTRO)

regress TEST TREAT_AFTER TREAT AFTER stratum_c2-stratum_c16, robust cluster(COD_CENTRO)

**  Blaanced panel

regress TEST TREAT_AFTER TREAT AFTER if balanced_sample==1, robust cluster(COD_CENTRO)

regress TEST TREAT_AFTER TREAT AFTER stratum_c2-stratum_c16 if balanced_sample==1, robust cluster(COD_CENTRO)



